FROM python:3.12.2-slim
ENV FLYWHEEL="/flywheel/v0"
RUN mkdir -p ${FLYWHEEL}
WORKDIR ${FLYWHEEL}

# version to install
ENV FSL_VERSION=6.0.7.7

RUN apt-get update \
    && apt-get install -y \
        wget \
        bc

# get the fslinstaller.py from official repo, v3.9.0 of fslinstaller.py
RUN wget -O /tmp/fslinstaller.py https://git.fmrib.ox.ac.uk/fsl/conda/installer/-/raw/3.9.0/fsl/installer/fslinstaller.py

# install
RUN python /tmp/fslinstaller.py --fslversion=${FSL_VERSION} -d /usr/share/fsl/

# Set environment variables
ENV FSLDIR=/usr/share/fsl
ENV FSL_DIR="${FSLDIR}"
ENV PATH=/usr/share/fsl/bin/:$PATH
ENV FSLMULTIFILEQUIT=TRUE
ENV LD_LIBRARY_PATH=/usr/share/fsl/lib:$LD_LIBRARY_PATH
ENV FSLOUTPUTTYPE=NIFTI_GZ

COPY fsl_anat ${FLYWHEEL}/fsl_anat
COPY run.py ${FLYWHEEL}/

LABEL org.nrg.commands="[{\"name\": \"fsl_anat\", \"label\": \"fsl_anat\", \"description\": \"Runs fsl_anat v1.0. LICENSING NOTE: FSL software are owned by Oxford University Innovation and license is required for any commercial applications. For commercial licence please contact fsl@innovation.ox.ac.uk. For academic use, an academic license is required which is available by registering on the FSL website. Any use of the software requires that the user obtain the appropriate license. See https://fsl.fmrib.ox.ac.uk/fsldownloads_registration for more information.\", \"version\": \"1.0\", \"schema-version\": \"1.0\", \"image\": \"registry.gitlab.com/flywheel-io/clinical-solutions/xnat-cs-containers/fsl-anat:1.0\", \"type\": \"docker\", \"command-line\": \"python run.py --input_dir /input --output_dir /output -o fsl_anat #BETFPARAM# #IMAGE_TYPE# #BIAS_SMOOTH# #WEAKBIAS# #NO_REORIENT# #NO_CROP# #NO_BIAS# #NO_REG# #NO_NONLINREG# #NO_SEG# #NO_SUBCORTSEG# #NO_SEARCH# #NO_CLEANUP#\", \"override-entrypoint\": true, \"mounts\": [{\"name\": \"in\", \"writable\": false, \"path\": \"/input\"}, {\"name\": \"out\", \"writable\": true, \"path\": \"/output\"}], \"environment-variables\": {}, \"ports\": {}, \"inputs\": [{\"name\": \"betfparam\", \"description\": \"specify f parameter for BET (this is only used if you're not running non-linear reg, and if you want brain extraction done).\", \"type\": \"number\", \"default-value\": \"0.1\", \"required\": true, \"replacement-key\": \"#BETFPARAM#\", \"command-line-flag\": \"--betfparam\", \"command-line-separator\": \"=\", \"select-values\": []}, {\"name\": \"ImageType\", \"description\": \"Specify the type of image. T1, T2, PD are possible options.\", \"type\": \"string\", \"default-value\": \"T1\", \"required\": true, \"replacement-key\": \"#IMAGE_TYPE#\", \"command-line-flag\": \"-t\", \"command-line-separator\": \" \", \"select-values\": []}, {\"name\": \"BiasField_smoothing\", \"description\": \"Specify the value for bias field smoothing (-l option in FAST).\", \"type\": \"number\", \"default-value\": \"10\", \"required\": true, \"replacement-key\": \"#BIAS_SMOOTH#\", \"command-line-flag\": \"-s\", \"command-line-separator\": \" \", \"select-values\": []}, {\"name\": \"weakbias\", \"description\": \"Used for images with little and/or smooth bias fields. Also will overwrite BiasField_smoothing to be 20 when run. The bias-field correction assumes that the field is 'strong', typical of that arising from a multi-coil array or a high-field scanner. For images acquired using birdcage coils or on 1.5T scanners, the --weakbias option will be faster and may produce equally good results.\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#WEAKBIAS#\", \"true-value\": \"--weakbias\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"noreorient\", \"description\": \"Turn off the step that does reorientation to standard (fslreorient2std)\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#NO_REORIENT#\", \"true-value\": \"--noreorient\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"nocrop\", \"description\": \"Turn off step that does automated cropping (robustfov)\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#NO_CROP#\", \"true-value\": \"--nocrop\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"nobias\", \"description\": \"Turn off steps that do bias field correction (via FAST)\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#NO_BIAS#\", \"true-value\": \"--nobias\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"noreg\", \"description\": \"Turn off steps that do registration to standard (FLIRT and FNIRT)\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#NO_REG#\", \"true-value\": \"--noreg\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"nononlinreg\", \"description\": \"Turn off step that does non-linear registration (FNIRT)\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#NO_NONLINREG#\", \"true-value\": \"--nononlinreg\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"noseg\", \"description\": \"Turn off step that does tissue-type segmentation (FAST)\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#NO_SEG#\", \"true-value\": \"--noseg\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"nosubcortseg\", \"description\": \"Turn off step that does sub-cortical segmentation (FIRST)\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#NO_SUBCORTSEG#\", \"true-value\": \"--nosubcortseg\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"nosearch\", \"description\": \"Specify that linear registration uses the -nosearch option (FLIRT)\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#NO_SEARCH#\", \"true-value\": \"--nosearch\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"nocleanup\", \"description\": \"Do not remove intermediate files.\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#NO_CLEANUP#\", \"true-value\": \"--nocleanup\", \"false-value\": \"\", \"select-values\": []}], \"outputs\": [{\"name\": \"fsl_anat\", \"description\": \"fsl_anat\", \"required\": true, \"mount\": \"out\", \"glob\": \"\"}], \"xnat\": [{\"name\": \"fsl_anat\", \"label\": \"fsl_anat-v1.0\", \"description\": \"Run fsl_anat v1.0\", \"contexts\": [\"xnat:imageScanData\"], \"external-inputs\": [{\"name\": \"scan\", \"description\": \"Input scan\", \"type\": \"Scan\", \"required\": true, \"provides-files-for-command-mount\": \"in\", \"load-children\": false}], \"derived-inputs\": [], \"output-handlers\": [{\"name\": \"fsl_anat\", \"accepts-command-output\": \"fsl_anat\", \"as-a-child-of\": \"scan\", \"type\": \"Resource\", \"label\": \"fsl_anat\", \"tags\": []}]}], \"reserve-memory\": 1000, \"container-labels\": {}, \"generic-resources\": {}, \"ulimits\": {}, \"secrets\": []}]"
